/*-----------------------------------------------------------*/

FUNCTION WINDOW (position,length,width,wline,fill,newcolor,oldscrn)
* Open a window of specified width and length in a specified location
* Store SaveScreen() for window coords to param OLDSCRN if passed (by ref)

local w_single,w_double,windok,special
public c1,c2,c3,c4
w_single = CHR(218)+CHR(196)+CHR(191)+CHR(179)+CHR(217)+CHR(196)+;
         CHR(192)+CHR(179)+chr(fill)
w_double = CHR(201)+CHR(205)+CHR(187)+CHR(186)+CHR(188)+CHR(205)+;
         CHR(200)+CHR(186)+chr(fill)
position = upper(position)
windok = .f.
do while .t.

   if len(position) # 2 .or. (.not. substr(position,1,1) $ 'TCB') .or.;
                             (.not. substr(position,2,1) $ 'RCL') .or.;
                             length > 24 .or. width > 79
      setcolor('w+/n')
      @ 11,24,13,55 box w_single
      @ 12,25 say [ Invalid Window() Parameters! ]
      exit
   endif

   if wline >= 0
      special = CHR(wline)+CHR(wline)+CHR(wline)+CHR(wline)+CHR(wline)+CHR(wline)+;
                CHR(wline)+CHR(wline)+chr(fill)
   endif

   DO CASE
   case substr(position,1,1) = 'T'
      c1 = 0
   case substr(position,1,1) = 'C'
      c1 = (24 - length) / 2
   case substr(position,1,1) = 'B'
      c1 = 24 - length
   ENDCASE

   DO CASE
   case substr(position,2,1) = 'L'
      c2 = 0
   case substr(position,2,1) = 'C'
      c2 = (79 - width) / 2
   case substr(position,2,1) = 'R'
      c2 = 79 - width
   ENDCASE

   c3 = c1 + length
   c4 = c2 + width

	oldscrn = savescreen(c1,c2,c3,c4)

   setcolor(newcolor)
   @ c1,c2,c3,c4 box ""
   DO CASE
   case wline = -1
      @ c1,c2,c3,c4 box w_single
   case wline = -2
      @ c1,c2,c3,c4 box w_double
   otherwise
      @ c1,c2,c3,c4 box special
   ENDCASE
   windok = .t.
   exit

enddo [t]

return (windok)

/*-----------------------------------------------------------*/

FUNCTION GREATER(numa,numb)
* returns the greater of two numbers

if numa > numb
   return (numa)
else
   return (numb)
endif

/*-----------------------------------------------------------*/

FUNCTION DSCENTER (mess, left,  right)
* Old format:    left, right, mess

local gcol,realmess

if pcount() = 1				// only mess passed
	left = 0						// so use full-screen defaults
	right = 79

elseif valtype(mess) = "N"	// assume old format parameters used
	realmess = right			// and make appropriate adjustments
	right = left
	left = mess
	mess = realmess

endif

gcol = left + ( ((right-left)-len(mess)) / 2)
return(gcol)

/*-----------------------------------------------------------*/

Function LSI(num)
return ltrim(str(int(num)))

/*----------------------------------------------------------------------*/